diff --git a/testing/mozbase/mozprofile/tests/addon_stubs.py b/testing/mozbase/mozprofile/tests/addon_stubs.py
index f9602de462..9675e314d8 100644
--- a/testing/mozbase/mozprofile/tests/addon_stubs.py
+++ b/testing/mozbase/mozprofile/tests/addon_stubs.py
@@ -34,23 +34,23 @@ def generate_addon(addon_id, path=None, name=None, xpi=True):
     Returns the file-path of the addon's .xpi file
     """
 
-    if addon_id not in stubs.keys():
-        raise IOError('Requested addon stub "%s" does not exist' % addon_id)
+    if addon_id not in list(stubs.keys()):
+        raise OSError('Requested addon stub "%s" does not exist' % addon_id)
 
     # Generate directory structure for addon
     try:
         tmpdir = path or tempfile.mkdtemp()
         addon_dir = os.path.join(tmpdir, name or addon_id)
         os.mkdir(addon_dir)
-    except IOError:
-        raise IOError('Could not generate directory structure for addon stub.')
+    except OSError:
+        raise OSError('Could not generate directory structure for addon stub.')
 
     # Write install.rdf for addon
     if stubs[addon_id]:
         install_rdf = os.path.join(addon_dir, 'install.rdf')
         with open(install_rdf, 'w') as f:
             manifest = os.path.join(here, 'install_manifests', stubs[addon_id])
-            f.write(open(manifest, 'r').read())
+            f.write(open(manifest).read())
 
     if not xpi:
         return addon_dir
diff --git a/testing/mozbase/mozprofile/tests/server_locations.py b/testing/mozbase/mozprofile/tests/server_locations.py
index 5aa5c0f5eb..6ab58879d1 100644
--- a/testing/mozbase/mozprofile/tests/server_locations.py
+++ b/testing/mozbase/mozprofile/tests/server_locations.py
@@ -60,21 +60,21 @@ http://example.org:80           privileged
         # ensure that they're what we expect
         self.assertEqual(len(locations), 6)
         i = iter(locations)
-        self.compare_location(i.next(), 'http', 'mochi.test', '8888',
+        self.compare_location(next(i), 'http', 'mochi.test', '8888',
                               ['primary', 'privileged'])
-        self.compare_location(i.next(), 'http', '127.0.0.1', '80',
+        self.compare_location(next(i), 'http', '127.0.0.1', '80',
                               ['privileged'])
-        self.compare_location(i.next(), 'http', '127.0.0.1', '8888',
+        self.compare_location(next(i), 'http', '127.0.0.1', '8888',
                               ['privileged'])
-        self.compare_location(i.next(), 'https', 'test', '80', ['privileged'])
-        self.compare_location(i.next(), 'http', 'example.org', '80',
+        self.compare_location(next(i), 'https', 'test', '80', ['privileged'])
+        self.compare_location(next(i), 'http', 'example.org', '80',
                               ['privileged'])
-        self.compare_location(i.next(), 'http', 'test1.example.org', '8888',
+        self.compare_location(next(i), 'http', 'test1.example.org', '8888',
                               ['privileged'])
 
         locations.add_host('mozilla.org')
         self.assertEqual(len(locations), 7)
-        self.compare_location(i.next(), 'http', 'mozilla.org', '80',
+        self.compare_location(next(i), 'http', 'mozilla.org', '80',
                               ['privileged'])
 
         # test some errors
@@ -116,7 +116,7 @@ http://example.org:80           privileged
         self.assertEqual(exc.lineno, 4)
 
     def test_server_locations_callback(self):
-        class CallbackTest(object):
+        class CallbackTest:
             last_locations = None
 
             def callback(self, locations):
diff --git a/testing/mozbase/mozprofile/tests/test_addons.py b/testing/mozbase/mozprofile/tests/test_addons.py
index 93b930feac..171c6ce497 100644
--- a/testing/mozbase/mozprofile/tests/test_addons.py
+++ b/testing/mozbase/mozprofile/tests/test_addons.py
@@ -8,7 +8,7 @@ import os
 import shutil
 import tempfile
 import unittest
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 
 from manifestparser import ManifestParser
 import mozfile
@@ -17,6 +17,7 @@ import mozlog.unstructured as mozlog
 import mozprofile
 
 from addon_stubs import generate_addon, generate_manifest
+import six
 
 
 here = os.path.dirname(os.path.abspath(__file__))
@@ -99,7 +100,7 @@ class TestAddonsManager(unittest.TestCase):
 
         # Download from an invalid URL
         addon = server.get_url() + 'not_existent.xpi'
-        self.assertRaises(urllib2.HTTPError,
+        self.assertRaises(six.moves.urllib.error.HTTPError,
                           self.am.download, addon, self.tmpdir)
         self.assertEqual(os.listdir(self.tmpdir), [])
 
@@ -122,7 +123,7 @@ class TestAddonsManager(unittest.TestCase):
             self.am.install_from_path(temp_addon)
 
         # Generate a list of addons installed in the profile
-        addons_installed = [unicode(x[:-len('.xpi')]) for x in os.listdir(os.path.join(
+        addons_installed = [str(x[:-len('.xpi')]) for x in os.listdir(os.path.join(
                             self.profile.profile, 'extensions', 'staged'))]
         self.assertEqual(addons_to_install.sort(), addons_installed.sort())
 
@@ -287,7 +288,7 @@ class TestAddonsManager(unittest.TestCase):
 
         self.am.install_from_manifest(temp_manifest)
         # Generate a list of addons installed in the profile
-        addons_installed = [unicode(x[:-len('.xpi')]) for x in os.listdir(os.path.join(
+        addons_installed = [str(x[:-len('.xpi')]) for x in os.listdir(os.path.join(
                             self.profile.profile, 'extensions', 'staged'))]
         self.assertEqual(addons_installed.sort(), addons_to_install.sort())
 
@@ -327,7 +328,7 @@ class TestAddonsManager(unittest.TestCase):
         addon_two = generate_addon('test-addon-2@mozilla.org')
 
         self.am.install_addons(addon_one)
-        installed_addons = [unicode(x[:-len('.xpi')]) for x in os.listdir(os.path.join(
+        installed_addons = [str(x[:-len('.xpi')]) for x in os.listdir(os.path.join(
                             self.profile.profile, 'extensions', 'staged'))]
 
         # Create a new profile based on an existing profile
@@ -337,7 +338,7 @@ class TestAddonsManager(unittest.TestCase):
                                                        addons=addon_two)
         duplicate_profile.addon_manager.clean()
 
-        addons_after_cleanup = [unicode(x[:-len('.xpi')]) for x in os.listdir(os.path.join(
+        addons_after_cleanup = [str(x[:-len('.xpi')]) for x in os.listdir(os.path.join(
                                 duplicate_profile.profile, 'extensions', 'staged'))]
         # New addons installed should be removed by clean_addons()
         self.assertEqual(installed_addons, addons_after_cleanup)
diff --git a/testing/mozbase/mozprofile/tests/test_preferences.py b/testing/mozbase/mozprofile/tests/test_preferences.py
index 45d99c2e27..9ff9fc62dc 100755
--- a/testing/mozbase/mozprofile/tests/test_preferences.py
+++ b/testing/mozbase/mozprofile/tests/test_preferences.py
@@ -62,9 +62,9 @@ class PreferencesTest(unittest.TestCase):
 
         _prefs = {"browser.startup.homepage": "http://planet.mozilla.org/"}
         commandline = []
-        _prefs = _prefs.items()
+        _prefs = list(_prefs.items())
         for pref, value in _prefs:
-            commandline += ["--pref", "%s:%s" % (pref, value)]
+            commandline += ["--pref", "{}:{}".format(pref, value)]
         self.compare_generated(_prefs, commandline)
 
     def test_ordered_prefs(self):
@@ -75,7 +75,7 @@ class PreferencesTest(unittest.TestCase):
                   ("webgl.verbose", 'false')]
         commandline = []
         for pref, value in _prefs:
-            commandline += ["--pref", "%s:%s" % (pref, value)]
+            commandline += ["--pref", "{}:{}".format(pref, value)]
         _prefs = [(i, Preferences.cast(j)) for i, j in _prefs]
         self.compare_generated(_prefs, commandline)
 
@@ -138,14 +138,14 @@ general.warnOnAboutConfig = False
         # we shouldn't have any initial preferences
         initial_prefs = Preferences.read_prefs(prefs_file)
         self.assertFalse(initial_prefs)
-        initial_prefs = file(prefs_file).read().strip()
+        initial_prefs = open(prefs_file).read().strip()
         self.assertFalse(initial_prefs)
 
         # add some preferences
         prefs1 = [("mr.t.quotes", "i aint getting on no plane!")]
         profile.set_preferences(prefs1)
         self.assertEqual(prefs1, Preferences.read_prefs(prefs_file))
-        lines = file(prefs_file).read().strip().splitlines()
+        lines = open(prefs_file).read().strip().splitlines()
         self.assertTrue(any(line.startswith('#MozRunner Prefs Start') for line in lines))
         self.assertTrue(any(line.startswith('#MozRunner Prefs End') for line in lines))
 
@@ -162,14 +162,14 @@ general.warnOnAboutConfig = False
         # we shouldn't have any initial preferences
         initial_prefs = Preferences.read_prefs(prefs_file)
         self.assertFalse(initial_prefs)
-        initial_prefs = file(prefs_file).read().strip()
+        initial_prefs = open(prefs_file).read().strip()
         self.assertFalse(initial_prefs)
 
         # add some preferences
         prefs1 = [("mr.t.quotes", "i aint getting on no plane!")]
         profile.set_persistent_preferences(prefs1)
         self.assertEqual(prefs1, Preferences.read_prefs(prefs_file))
-        lines = file(prefs_file).read().strip().splitlines()
+        lines = open(prefs_file).read().strip().splitlines()
         self.assertTrue(any(line.startswith('#MozRunner Prefs Start') for line in lines))
         self.assertTrue(any(line.startswith('#MozRunner Prefs End') for line in lines))
 
@@ -187,7 +187,7 @@ general.warnOnAboutConfig = False
         # we shouldn't have any initial preferences
         initial_prefs = Preferences.read_prefs(prefs_file)
         self.assertFalse(initial_prefs)
-        initial_prefs = file(prefs_file).read().strip()
+        initial_prefs = open(prefs_file).read().strip()
         self.assertFalse(initial_prefs)
 
         # add some preferences
@@ -195,7 +195,7 @@ general.warnOnAboutConfig = False
                   ("zoom.minPercent", 30)]
         profile.set_preferences(prefs1)
         self.assertEqual(prefs1, Preferences.read_prefs(prefs_file))
-        lines = file(prefs_file).read().strip().splitlines()
+        lines = open(prefs_file).read().strip().splitlines()
         self.assertTrue(bool([line for line in lines
                               if line.startswith('#MozRunner Prefs Start')]))
         self.assertTrue(bool([line for line in lines
@@ -206,7 +206,7 @@ general.warnOnAboutConfig = False
                   ("webgl.verbose", 'false')]
         profile.set_preferences(prefs2)
         self.assertEqual(prefs1 + prefs2, Preferences.read_prefs(prefs_file))
-        lines = file(prefs_file).read().strip().splitlines()
+        lines = open(prefs_file).read().strip().splitlines()
         self.assertTrue(len([line for line in lines
                              if line.startswith('#MozRunner Prefs Start')]) == 2)
         self.assertTrue(len([line for line in lines
@@ -216,7 +216,7 @@ general.warnOnAboutConfig = False
         profile.clean_preferences()
         final_prefs = Preferences.read_prefs(prefs_file)
         self.assertFalse(final_prefs)
-        lines = file(prefs_file).read().strip().splitlines()
+        lines = open(prefs_file).read().strip().splitlines()
         self.assertTrue('#MozRunner Prefs Start' not in lines)
         self.assertTrue('#MozRunner Prefs End' not in lines)
 
@@ -233,7 +233,7 @@ user_pref("webgl.enabled_for_all_sites", true);
 user_pref("webgl.force-enabled", true);
 """
             user_js = os.path.join(tempdir, 'user.js')
-            f = file(user_js, 'w')
+            f = open(user_js, 'w')
             f.write(contents)
             f.close()
 
diff --git a/testing/mozbase/mozprofile/tests/test_profile_view.py b/testing/mozbase/mozprofile/tests/test_profile_view.py
index 2e10a913bd..f6a56e708d 100644
--- a/testing/mozbase/mozprofile/tests/test_profile_view.py
+++ b/testing/mozbase/mozprofile/tests/test_profile_view.py
@@ -20,9 +20,9 @@ class TestProfilePrint(unittest.TestCase):
         test the summary function
         """
 
-        keys = set(['Files', 'Path', 'user.js'])
+        keys = {'Files', 'Path', 'user.js'}
         ff_prefs = mozprofile.FirefoxProfile.preferences  # shorthand
-        pref_string = '\n'.join(['%s: %s' % (key, ff_prefs[key])
+        pref_string = '\n'.join(['{}: {}'.format(key, ff_prefs[key])
                                  for key in sorted(ff_prefs.keys())])
 
         tempdir = tempfile.mkdtemp()
@@ -57,17 +57,17 @@ class TestProfilePrint(unittest.TestCase):
 
         # diff two profiles
         diff = dict(mozprofile.diff(profile1, profile2))
-        self.assertEqual(diff.keys(), ['user.js'])
+        self.assertEqual(list(diff.keys()), ['user.js'])
         lines = [line.strip() for line in diff['user.js'].splitlines()]
         self.assertTrue('+foo: bar' in lines)
 
         # diff a blank vs FirefoxProfile
         ff_profile = mozprofile.FirefoxProfile()
         diff = dict(mozprofile.diff(profile2, ff_profile))
-        self.assertEqual(diff.keys(), ['user.js'])
+        self.assertEqual(list(diff.keys()), ['user.js'])
         lines = [line.strip() for line in diff['user.js'].splitlines()]
         self.assertTrue('-foo: bar' in lines)
-        ff_pref_lines = ['+%s: %s' % (key, value)
+        ff_pref_lines = ['+{}: {}'.format(key, value)
                          for key, value in mozprofile.FirefoxProfile.preferences.items()]
         self.assertTrue(set(ff_pref_lines).issubset(lines))
 
diff --git a/testing/mozbase/mozprofile/tests/test_webapps.py b/testing/mozbase/mozprofile/tests/test_webapps.py
index 4db992d696..e72bb5ae4e 100755
--- a/testing/mozbase/mozprofile/tests/test_webapps.py
+++ b/testing/mozbase/mozprofile/tests/test_webapps.py
@@ -94,7 +94,7 @@ class WebappTest(unittest.TestCase):
         self.assertEqual(len(webapps), 2)
         self.assertTrue(webapp_1 in webapps)
         self.assertTrue(webapp_2 in webapps)
-        self.assertNotEquals(webapps[0], webapps[1])
+        self.assertNotEqual(webapps[0], webapps[1])
 
         # Insert a webapp object
         webapps.insert(1, webapp_3)
diff --git a/testing/mozbase/mozrunner/mozrunner/__init__.py b/testing/mozbase/mozrunner/mozrunner/__init__.py
index 0fec5c2386..5753de41f8 100644
--- a/testing/mozbase/mozrunner/mozrunner/__init__.py
+++ b/testing/mozbase/mozrunner/mozrunner/__init__.py
@@ -6,6 +6,6 @@ from .cli import *
 from .errors import *
 from .runners import *
 
-import base
-import devices
-import utils
+from . import base
+from . import devices
+from . import utils
diff --git a/testing/mozbase/mozrunner/mozrunner/application.py b/testing/mozbase/mozrunner/mozrunner/application.py
index 6734487ae6..eb874cfa5a 100644
--- a/testing/mozbase/mozrunner/mozrunner/application.py
+++ b/testing/mozbase/mozrunner/mozrunner/application.py
@@ -15,6 +15,7 @@ from mozprofile import (
     MetroFirefoxProfile,
     ThunderbirdProfile
 )
+import six
 
 here = os.path.abspath(os.path.dirname(__file__))
 
@@ -31,12 +32,11 @@ def get_app_context(appname):
     return context_map[appname]
 
 
-class DefaultContext(object):
+class DefaultContext:
     profile_class = Profile
 
 
-class RemoteContext(object):
-    __metaclass__ = ABCMeta
+class RemoteContext(six.with_metaclass(ABCMeta)):
     _dm = None
     _remote_profile = None
     _adb = None
@@ -243,15 +243,15 @@ class B2GContext(RemoteContext):
             self.dm.shellCheckOutput(['touch', self.remote_settings_db])
 
 
-class FirefoxContext(object):
+class FirefoxContext:
     profile_class = FirefoxProfile
 
 
-class ThunderbirdContext(object):
+class ThunderbirdContext:
     profile_class = ThunderbirdProfile
 
 
-class MetroContext(object):
+class MetroContext:
     profile_class = MetroFirefoxProfile
 
     def __init__(self, binary=None):
diff --git a/testing/mozbase/mozrunner/mozrunner/base/browser.py b/testing/mozbase/mozrunner/mozrunner/base/browser.py
index 6fc7348d58..9b53d09d34 100644
--- a/testing/mozbase/mozrunner/mozrunner/base/browser.py
+++ b/testing/mozbase/mozrunner/mozrunner/base/browser.py
@@ -35,7 +35,7 @@ class GeckoRuntimeRunner(BaseRunner):
         if sys.platform == 'linux2' and self.binary.endswith('-bin'):
             dirname = os.path.dirname(self.binary)
             if os.environ.get('LD_LIBRARY_PATH', None):
-                self.env['LD_LIBRARY_PATH'] = '%s:%s' % (os.environ['LD_LIBRARY_PATH'], dirname)
+                self.env['LD_LIBRARY_PATH'] = '{}:{}'.format(os.environ['LD_LIBRARY_PATH'], dirname)
             else:
                 self.env['LD_LIBRARY_PATH'] = dirname
 
diff --git a/testing/mozbase/mozrunner/mozrunner/base/device.py b/testing/mozbase/mozrunner/mozrunner/base/device.py
index 6eeef042f4..14b2ba59b9 100644
--- a/testing/mozbase/mozrunner/mozrunner/base/device.py
+++ b/testing/mozbase/mozrunner/mozrunner/base/device.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import print_function
 
+from __future__ import print_function
 import datetime
 import re
 import signal
@@ -59,8 +59,8 @@ class DeviceRunner(BaseRunner):
         if self.app_ctx.dm._deviceSerial:
             cmd.extend(['-s', self.app_ctx.dm._deviceSerial])
         cmd.append('shell')
-        for k, v in self._device_env.iteritems():
-            cmd.append('%s=%s' % (k, v))
+        for k, v in self._device_env.items():
+            cmd.append('{}={}'.format(k, v))
         cmd.append(self.app_ctx.remote_binary)
         return cmd
 
@@ -87,7 +87,7 @@ class DeviceRunner(BaseRunner):
                 break
             time.sleep(1)
         else:
-            print("timed out waiting for '%s' process to start" % self.app_ctx.remote_process)
+            print(("timed out waiting for '%s' process to start" % self.app_ctx.remote_process))
 
         if not self.device.wait_for_net():
             raise Exception("Failed to get a network connection")
@@ -108,17 +108,17 @@ class DeviceRunner(BaseRunner):
             self.app_ctx.dm.killProcess(
                 self.app_ctx.remote_process, sig=sig)
             if not _wait_for_shutdown(remote_pid) and sig is not None:
-                print("timed out waiting for '%s' process to exit, trying "
+                print(("timed out waiting for '%s' process to exit, trying "
                       "without signal {}".format(
-                          self.app_ctx.remote_process, sig))
+                          self.app_ctx.remote_process, sig)))
 
             # need to call adb stop otherwise the system will attempt to
             # restart the process
             remote_pid = self.is_running() or remote_pid
             self.app_ctx.stop_application()
             if not _wait_for_shutdown(remote_pid):
-                print("timed out waiting for '%s' process to exit".format(
-                    self.app_ctx.remote_process))
+                print(("timed out waiting for '%s' process to exit".format(
+                    self.app_ctx.remote_process)))
 
     def is_running(self):
         return self.app_ctx.dm.processExist(self.app_ctx.remote_process)
@@ -137,7 +137,7 @@ class DeviceRunner(BaseRunner):
             timeout = self.output_timeout
             msg = "%s with no output" % msg
 
-        print(msg % (self.last_test, timeout))
+        print((msg % (self.last_test, timeout)))
         self.check_for_crashes()
 
     def on_finish(self):
@@ -163,7 +163,7 @@ class DeviceRunner(BaseRunner):
 class FennecRunner(DeviceRunner):
 
     def __init__(self, cmdargs=None, **kwargs):
-        super(FennecRunner, self).__init__(**kwargs)
+        super().__init__(**kwargs)
         self.cmdargs = cmdargs or []
 
     @property
@@ -178,7 +178,7 @@ class FennecRunner(DeviceRunner):
         app_params.extend(self.cmdargs)
         am_subcommand.extend(["--es", "args", "'%s'" % " ".join(app_params)])
         # Append env variables in the form |--es env0 MOZ_CRASHREPORTER=1|
-        for (count, (k, v)) in enumerate(self._device_env.iteritems()):
-            am_subcommand.extend(["--es", "env%d" % count, "%s=%s" % (k, v)])
+        for (count, (k, v)) in enumerate(self._device_env.items()):
+            am_subcommand.extend(["--es", "env%d" % count, "{}={}".format(k, v)])
         cmd.append("%s" % " ".join(am_subcommand))
         return cmd
diff --git a/testing/mozbase/mozrunner/mozrunner/base/runner.py b/testing/mozbase/mozrunner/mozrunner/base/runner.py
index 98628f6f33..f187bcf680 100644
--- a/testing/mozbase/mozrunner/mozrunner/base/runner.py
+++ b/testing/mozbase/mozrunner/mozrunner/base/runner.py
@@ -10,6 +10,7 @@ import traceback
 
 from mozlog import get_default_logger
 from mozprocess import ProcessHandler
+import six
 try:
     import mozcrash
 except ImportError:
@@ -19,11 +20,10 @@ from ..application import DefaultContext
 from ..errors import RunnerNotStartedError
 
 
-class BaseRunner(object):
+class BaseRunner(six.with_metaclass(ABCMeta)):
     """
     The base runner class for all mozrunner objects, both local and remote.
     """
-    __metaclass__ = ABCMeta
     last_test = 'mozrunner-startup'
     process_handler = None
     timeout = None
@@ -34,7 +34,7 @@ class BaseRunner(object):
                  dump_save_path=None, addons=None):
         self.app_ctx = app_ctx or DefaultContext()
 
-        if isinstance(profile, basestring):
+        if isinstance(profile, str):
             self.profile = self.app_ctx.profile_class(profile=profile,
                                                       addons=addons)
         else:
diff --git a/testing/mozbase/mozrunner/mozrunner/cli.py b/testing/mozbase/mozrunner/mozrunner/cli.py
index 9b340edb66..657f088f74 100644
--- a/testing/mozbase/mozrunner/mozrunner/cli.py
+++ b/testing/mozbase/mozrunner/mozrunner/cli.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import os
 import sys
 
@@ -63,7 +64,7 @@ class CLI(MozProfileCLI):
             self.profile_class = get_app_context(app).profile_class
         except KeyError:
             self.parser.error('Application "%s" unknown (should be one of "%s")' %
-                              (app, ', '.join(runners.keys())))
+                              (app, ', '.join(list(runners.keys()))))
 
     def add_options(self, parser):
         """add options to the parser"""
@@ -95,7 +96,7 @@ class CLI(MozProfileCLI):
 
     def command_args(self):
         """additional arguments for the mozilla application"""
-        return map(os.path.expanduser, self.options.appArgs)
+        return list(map(os.path.expanduser, self.options.appArgs))
 
     def runner_args(self):
         """arguments to instantiate the runner class"""
@@ -137,7 +138,7 @@ class CLI(MozProfileCLI):
         # attach a debugger if specified
         debug_args, interactive = self.debugger_arguments()
         runner.start(debug_args=debug_args, interactive=interactive)
-        print 'Starting: ' + ' '.join(runner.command)
+        print(('Starting: ' + ' '.join(runner.command)))
         try:
             runner.wait()
         except KeyboardInterrupt:
diff --git a/testing/mozbase/mozrunner/mozrunner/devices/__init__.py b/testing/mozbase/mozrunner/mozrunner/devices/__init__.py
index bdb7586c90..26f816ab17 100644
--- a/testing/mozbase/mozrunner/mozrunner/devices/__init__.py
+++ b/testing/mozbase/mozrunner/mozrunner/devices/__init__.py
@@ -2,12 +2,12 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from emulator import BaseEmulator, Emulator, EmulatorAVD
-from base import Device
+from .emulator import BaseEmulator, Emulator, EmulatorAVD
+from .base import Device
 
-import emulator_battery
-import emulator_geo
-import emulator_screen
+from . import emulator_battery
+from . import emulator_geo
+from . import emulator_screen
 
 __all__ = ['BaseEmulator', 'Emulator', 'EmulatorAVD', 'Device',
            'emulator_battery', 'emulator_geo', 'emulator_screen']
diff --git a/testing/mozbase/mozrunner/mozrunner/devices/android_device.py b/testing/mozbase/mozrunner/mozrunner/devices/android_device.py
index 0052f473c9..6670c66774 100644
--- a/testing/mozbase/mozrunner/mozrunner/devices/android_device.py
+++ b/testing/mozbase/mozrunner/mozrunner/devices/android_device.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import fileinput
 import glob
 import os
@@ -12,8 +13,8 @@ import signal
 import sys
 import telnetlib
 import time
-import urlparse
-import urllib2
+import six.moves.urllib.parse
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 from distutils.spawn import find_executable
 
 from mozdevice import DeviceManagerADB, DMError
@@ -96,7 +97,7 @@ def verify_android_device(build_obj, install=False, xre=False, debugger=False, v
     if (len(devices) > 0) and ('device' in [d[1] for d in devices]):
         device_verified = True
     elif emulator.is_available():
-        response = raw_input(
+        response = input(
             "No Android devices connected. Start an emulator? (Y/n) ").strip()
         if response.lower().startswith('y') or response == '':
             if not emulator.check_avd():
@@ -124,7 +125,7 @@ def verify_android_device(build_obj, install=False, xre=False, debugger=False, v
         installed = emulator.dm.shellCheckOutput(['pm', 'list',
                                                   'packages', 'org.mozilla.'])
         if 'fennec' not in installed and 'firefox' not in installed:
-            response = raw_input(
+            response = input(
                 "It looks like Firefox is not installed on this device.\n"
                 "Install Firefox? (Y/n) ").strip()
             if response.lower().startswith('y') or response == '':
@@ -153,7 +154,7 @@ def verify_android_device(build_obj, install=False, xre=False, debugger=False, v
                     break
         if err:
             _log_info("Host utilities not found: %s" % err)
-            response = raw_input(
+            response = input(
                 "Download and setup your host utilities? (Y/n) ").strip()
             if response.lower().startswith('y') or response == '':
                 _log_info("Installing host utilities. This may take a while...")
@@ -188,7 +189,7 @@ def verify_android_device(build_obj, install=False, xre=False, debugger=False, v
             err = '%s not found' % gdb_path
         if err:
             _log_info("JimDB (%s) not found: %s" % (build_platform, err))
-            response = raw_input(
+            response = input(
                 "Download and setup JimDB (%s)? (Y/n) " % build_platform).strip()
             if response.lower().startswith('y') or response == '':
                 host_platform = _get_host_platform()
@@ -252,7 +253,7 @@ def run_firefox_for_android(build_obj, params):
         cmd = ['am', 'start', '-a', 'android.activity.MAIN', '-n', app]
         if params:
             for p in params:
-                if urlparse.urlparse(p).scheme != "":
+                if six.moves.urllib.parse.urlparse(p).scheme != "":
                     cmd.extend(['-d', p])
                     params.remove(p)
                     break
@@ -570,7 +571,7 @@ class AndroidEmulator(object):
         return telnet_ok
 
     def _get_avd_type(self, requested):
-        if requested in AVD_DICT.keys():
+        if requested in list(AVD_DICT.keys()):
             return requested
         if self.substs:
             if not self.substs['TARGET_CPU'].startswith('arm'):
@@ -646,23 +647,23 @@ def _find_sdk_exe(substs, exe, tools):
 
 def _log_debug(text):
     if verbose_logging:
-        print "DEBUG: %s" % text
+        print(("DEBUG: %s" % text))
 
 
 def _log_warning(text):
-    print "WARNING: %s" % text
+    print(("WARNING: %s" % text))
 
 
 def _log_info(text):
-    print "%s" % text
+    print(("%s" % text))
 
 
 def _download_file(url, filename, path):
-    f = urllib2.urlopen(url)
+    f = six.moves.urllib.request.urlopen(url)
     if not os.path.isdir(path):
         try:
             os.makedirs(path)
-        except Exception, e:
+        except Exception as e:
             _log_warning(str(e))
             return False
     local_file = open(os.path.join(path, filename), 'wb')
@@ -676,7 +677,7 @@ def _get_tooltool_manifest(substs, src_path, dst_path, filename):
     if not os.path.isdir(dst_path):
         try:
             os.makedirs(dst_path)
-        except Exception, e:
+        except Exception as e:
             _log_warning(str(e))
     copied = False
     if substs and 'top_srcdir' in substs:
@@ -750,13 +751,13 @@ def _update_gdbinit(substs, path):
         # update existing objdir/srcroot in place
         for line in fileinput.input(path, inplace=True):
             if "feninit.default.objdir" in line and substs and 'MOZ_BUILD_ROOT' in substs:
-                print("python feninit.default.objdir = '%s'" % substs['MOZ_BUILD_ROOT'])
+                print(("python feninit.default.objdir = '%s'" % substs['MOZ_BUILD_ROOT']))
                 obj_replaced = True
             elif "feninit.default.srcroot" in line and substs and 'top_srcdir' in substs:
-                print("python feninit.default.srcroot = '%s'" % substs['top_srcdir'])
+                print(("python feninit.default.srcroot = '%s'" % substs['top_srcdir']))
                 src_replaced = True
             else:
-                print(line.strip())
+                print((line.strip()))
         # append objdir/srcroot if not updated
         if (not obj_replaced) and substs and 'MOZ_BUILD_ROOT' in substs:
             with open(path, "a") as f:
